Bug 1562519 - Review Request: git-crypt - transparent file encryption in git
Summary: Review Request: git-crypt - transparent file encryption in git
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Robert-André Mauchin 🐧
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2018-03-31 14:34 UTC by Christian Kellner
Modified: 2018-04-11 23:02 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2018-04-11 23:02:04 UTC
Type: ---
zebob.m: fedora-review+


Attachments (Terms of Use)

Description Christian Kellner 2018-03-31 14:34:05 UTC
Spec URL: https://github.com/gicmo/spec/blob/master/git-crypt/git-crypt.spec
SRPM URL: 
https://copr-be.cloud.fedoraproject.org/results/gicmo/git-crypt/fedora-rawhide-x86_64/00735276-git-crypt/git-crypt-0.6.0-1.fc29.src.rpm
https://kojipkgs.fedoraproject.org//work/tasks/3651/26083651/git-crypt-0.6.0-1.fc29.src.rpm
Koji scratch build: https://koji.fedoraproject.org/koji/taskinfo?taskID=26083650
Fedora Account System Username: gicmo
Description (taken from the spec file):
git-crypt enables transparent encryption and decryption of files in a
git repository. Files which you choose to protect are encrypted when
committed, and decrypted when checked out. git-crypt lets you freely
share a repository containing a mix of public and private
content. git-crypt gracefully degrades, so developers without the
secret key can still clone and commit to a repository with encrypted
files. This lets you store your secret material (such as keys or
passwords) in the same repository as your code, without requiring you
to lock down your entire repository.

Comment 1 Artur Frenszek-Iwicki 2018-03-31 14:58:26 UTC
>Summary: transparent file encryption in git
This should start with a capital (uppercase) letter.

>URL:     https://www.agwa.name/projects/git-crypt/
>Source0: https://www.agwa.name/projects/git-crypt/downloads/%{name}-%{version}.tar.gz
You can replace the beginning of Source0 with %{URL}.

>export DOCBOOK_XSL=/usr/share/sgml/docbook/xsl-stylesheets/manpages/docbook.xsl
I think %{_datadir} would be preferred here, instead of /usr/share.

>make install ENABLE_MAN=yes PREFIX=%{buildroot}/usr
Use %{_prefix} instead of /usr.

Comment 2 Christian Kellner 2018-03-31 15:14:04 UTC
Thanks for the review comments!

Hopefully addressed all of them.

New spec:
https://github.com/gicmo/spec/blob/master/git-crypt/git-crypt.spec

New scratch build:
https://koji.fedoraproject.org/koji/taskinfo?taskID=26084103

Comment 3 Robert-André Mauchin 🐧 2018-03-31 19:53:33 UTC
 - Add a BR to gcc-c++ See https://fedoraproject.org/wiki/Packaging:C_and_C%2B%2B :

BuildRequires:	gcc-c++

 - Define ldflags too:

export LDFLAGS="%{__global_ldflags}"

 - Use %make_install to install automatically in the buildroot:

%make_install ENABLE_MAN=yes PREFIX=%{_prefix}

 - Patch the Makefile to use "install -p" instead of "install" to keep timestamps:

%prep
%autosetup
sed -i "s|^\tinstall -|\t\$(INSTALL) -|" Makefile

 - There's some MIT code too:

MIT/X11 (BSD like)
------------------
git-crypt-0.6.0/fhstream.cpp
git-crypt-0.6.0/fhstream.hpp
git-crypt-0.6.0/parse_options.cpp
git-crypt-0.6.0/parse_options.hpp

   Add it to the license field and add a commet explaining the license breakdown.

 - Remove the INSTALL file from %doc:

git-crypt.x86_64: W: install-file-in-docs /usr/share/doc/git-crypt/INSTALL



Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "MIT/X11 (BSD like)", "GPL (v3 or later)", "Unknown or
     generated". 17 files have unknown license. Detailed output of
     licensecheck in /home/bob/packaging/review/git-crypt/review-git-
     crypt/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[!]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 30720 bytes in 4 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[!]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: git-crypt-0.6.0-2.fc29.x86_64.rpm
          git-crypt-debuginfo-0.6.0-2.fc29.x86_64.rpm
          git-crypt-debugsource-0.6.0-2.fc29.x86_64.rpm
          git-crypt-0.6.0-2.fc29.src.rpm
git-crypt.x86_64: W: spelling-error %description -l en_US decrypted -> encrypted
git-crypt.x86_64: W: only-non-binary-in-usr-lib
git-crypt.x86_64: W: install-file-in-docs /usr/share/doc/git-crypt/INSTALL
git-crypt-debugsource.x86_64: W: no-documentation
git-crypt.src: W: spelling-error %description -l en_US decrypted -> encrypted
4 packages and 0 specfiles checked; 0 errors, 5 warnings.

Comment 5 Robert-André Mauchin 🐧 2018-04-01 12:46:43 UTC
Seems good, package approved.

Comment 6 Jason Tibbitts 2018-04-03 16:35:40 UTC
(fedrepo-req-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/git-crypt

Comment 7 Fedora Update System 2018-04-04 09:04:22 UTC
git-crypt-0.6.0-3.fc28 has been submitted as an update to Fedora 28. https://bodhi.fedoraproject.org/updates/FEDORA-2018-74979395a9

Comment 8 Fedora Update System 2018-04-04 18:36:36 UTC
git-crypt-0.6.0-3.fc28 has been pushed to the Fedora 28 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2018-74979395a9

Comment 9 Fedora Update System 2018-04-11 23:02:04 UTC
git-crypt-0.6.0-3.fc28 has been pushed to the Fedora 28 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.